##############################################################
#  Copyright (C) 2007.3 Koji Tsukada
#      All rights reserved.
#      This is free software with ABSOLUTELY NO WARRANTY.
#
#  You can redistribute it and/or modify it under the terms of
#  the GNU General Public License version 2.
##############################################################

require 'shell'
require 'nkf'

module LedBoard
  class Client
    DEFAULT_MESSAGE = "Make: vol.2"
    DEFAULT_SPEED = 3
    
    WRITER_FILE = "./denkou.exe"
    MESSAGE_FILE = "./.message"
    SETTING_FILE = "./.denkourc"
    
    def write(message, speed)
      message = DEFAULT_MESSAGE if message == nil || message == ""
      
      if speed == nil || speed == ""
        speed = DEFAULT_SPEED
      else
        begin 
          speed = speed.to_i
        rescue
          speed = DEFAULT_SPEED
        end 
      end
      @setting['speed'] = speed
      save_setting
      save_message(message)
      write_loop
    end
    
    def nkf(message)
      if(@setting["encoding"] =~ /sjis/i)
        message = NKF.nkf("-s", message)
      else
        message = NKF.nkf("-e", message)
      end
      message
    end

    def save_data(file, data, flag = "w")
      File.open(file, flag) do |file|
        data.keys.each do |key|
          file.puts key + "\t" + data[key].to_s
        end
      end
    end
    
    def load_data(file)
      data = Hash.new
      if File.exist?(file)
        data = Hash.new {|hash, key| hash[key] = ""} #set default as ""
        File.open(file, "r") do |file|
          while((line = file.gets) != nil)
            line.chomp!
            key, value = line.split("\t")
            #puts args[0] + " " + args[1]
            data[key] = value
          end
        end
      end
      data
    end

    
    def save_setting
      File.open(SETTING_FILE, "w") do |file|
        @setting.keys.each do |key|
          file.puts key + " = " + @setting[key].to_s
        end
      end
    end
    
    def save_message(message)
      require "jcode"
      $KCODE = "s"
      message = message.tr('a-zA-Z0-9,./^;().. ',
                            '-`-yO-XCD^OGijDD@')
      #puts message
      
      base = 16
      length = 0
      
       File.open(MESSAGE_FILE, "w") do |file|
        while(length <= message.length)
          line = message[length, base]
          puts line
          file.puts line
          length += base
        end
       end
     
     #  File.open(MESSAGE_FILE, "w") do |file|
     #   file.puts message
     #  end
    end
    
	  def write_loop
		  command = WRITER_FILE + " " + MESSAGE_FILE	
      	
      begin
        Thread.start do
          system(command)#Kernel.system
        end
		  rescue p("Warning: #$!")
		  end
	  end
    
  end
end

