/**
 *   dfɕf[^𑗂郂W[
 */

#include "denkou.h"

/**
 *   𑗂ȌsB
 */
void dk_open(dcont_t *dcont)
{
  sio_t *scont = &dcont->scont;
  dcont->nol = 0;
  if(!dcont->no_out){
    if(dcont->b_rom_write){
      sio_cmd(scont,"rom_format");
    }
    else if(!dcont->no_scroll){
      sio_cmd(scont,"sc_clear");
      sio_cmd(scont,"sc_scroll");
    }
    else {
#if 1
      sio_cmd(scont,"sc_clear");
#endif
    }
  }
}

/**
 *   f[^]̌ns
 */
void dk_close(dcont_t *dcont)
{
  sio_t *scont = &dcont->scont;
  if(!dcont->no_out){
    if(dcont->b_rom_write){
      sio_cmd(scont,"rom_dclose");
      sio_cmd(scont,"rom_cwrite no comment");
      sio_cmd(scont,"rom_set speed %d",dcont->div);
      sio_cmd(scont,"rom_set bright %d", dcont->bright);
      sio_cmd(scont,"rom_set led_reverse %d", dcont->b_led_reverse);
#if 0
      sio_cmd(scont,"rom_scroll 0");  /* I XN[\ */
#endif
    }
    else if(!dcont->no_scroll)
      sio_cmd(scont,"sc_end");
    else
      sio_cmd(scont,"sc_show");
  }
}

/**
 *   f[^𑗂
 */
void dk_puts(dcont_t *dcont, const char *str)
{
  const char *p;
  dcont->char0 = 0;
  for(p=str;*p;p++)
    dk_putc(dcont,*p);
}

/**
 *   1oCgf[^Ƃ,dfɑ
 *
 *   R[h̔Aϊs
 */
void dk_putc(dcont_t *dcont, int c)
{
  static int nl = 0;

  if(c == '\r') return;
  if(c == '\n') {
    if(nl) c = ' ';
    else { nl = 1; return; }
  } else nl = 0;
  
  c = c & 0xff;

  if(dcont->encoding == Enc_SJIS){
    if(dcont->char0 > 0)                       /* SJIS: 2byte */
      sjis2euc(dcont->char0, c,&dcont->char0, &c);
    else if((c >= 0x80 && c <= 0x9f)||(c >= 0xe0 && c <= 0xfc)) {
      dcont->char0 = c;                        /* SJIS: 2byteR[h 1oCg */
      return;
    }
    else if(c > 0x80) 
      dcont->char0 = 0x8e;                     /* pJi */
  }

  if(dcont->char0 == 0x8e){
    dk_putchar(dcont, dcont->font1, c, dcont->b_vertical_ank);
    dcont->char0 = 0;
  }
  else if(dcont->char0 == 0){
    if(c < 0x80)
      dk_putchar(dcont, dcont->font1, c & 0x7f, dcont->b_vertical_ank);
    else
      dcont->char0 = c;
  }
  else {
    dk_putchar(dcont, dcont->font2, ((dcont->char0 & 0x7f)<< 8) + (c & 0x7f),
	       dcont->b_vertical);
    dcont->char0 = 0;
  }
}

/**
 *  H8̃obt@󂭂̂҂
 */
void dk_waitH8(dcont_t *dcont, int length)
{
  char *res;
  sio_t *scont = &dcont->scont;
  
  while(dcont->buf_left < length){
    usleep(100000);                                 /* wait 10mS */
    res = sio_cmd(scont, "sc_data");
    sscanf(res, "D %d", &dcont->buf_left);
    if(f_v > 1) fprintf(stderr,"buf_left = %d\n",dcont->buf_left); 
  }
}

/**
 *   ̃f[^dfɑ
 */
void dk_putchar(dcont_t *dcont,GuFont *font,int  c, int bVert)
{
  GuGlyph glyph;
  unsigned short bitmap[32];
  char  cmd[128],*s,*res;
  int i,w;
  sio_t *scont = &dcont->scont;

  
  /* tHgf[^擾 */
  guFontGlyph(font, c, &glyph);
  if(bVert)
    w = dk_get_glyph_bitmap_vertical(&glyph, bitmap, sizeof(bitmap)/sizeof(bitmap[0]));
  else
    w = dk_get_glyph_bitmap(&glyph, bitmap, sizeof(bitmap)/sizeof(bitmap[0]));

  if(!dcont->no_out && !dcont->no_scroll)
    dk_waitH8(dcont, w);
  
  /* o */
  
  if(!dcont->no_out){
    s = cmd;
    strcpy(s,dcont->b_rom_write ? "rom_dwrite" : "sc_data");
    s+=strlen(s);
    for(i=0;i<w;i++){
      sprintf(s," %x",bitmap[i]);
      s+=strlen(s);
    }
    res = sio_cmd(scont, cmd);
    if(sscanf(res, "D %d", &dcont->buf_left) == 0)
      dcont->buf_left = 0;
  }
  dcont->nol += w;
}

/**
 *   glyph̃f[^dfp 16bitf[^̔zɂĕԂB
 *
 *   @return f[^̒
 */

int dk_get_glyph_bitmap(GuGlyph *glyph,unsigned short *buf,int buflen)
{
  int h = glyph->ascent + glyph->descent;
  int w = glyph->width;
  int bpl = glyph->bpl;
  int m,x,y;
  unsigned short d;
  byte8 *p;

  if(h > 16)     h = 16;
  if(w > buflen) w = buflen;

  for(x=0;x<w;x++){
    p = glyph->bitmap + x / 8;
    m = 1 << (x % 8);
    d = 0;
    for(y=0;y<h;y++){
      d <<= 1;
      if(p[y*bpl] & m) d |= 1;
    }
    buf[x] = d;
  }
  return w;
}

/**
 *   c\pglyph̃f[^dfp 16bitf[^̔zɂĕԂB
 *
 *   @returen f[^̒
 */

int dk_get_glyph_bitmap_vertical(GuGlyph *glyph,unsigned short *buf,int buflen)
{
  int h = glyph->ascent + glyph->descent;	// 
  int w = glyph->width;				// 
  int bpl = glyph->bpl;
  int x,y;
  unsigned short d;

  if(w > 16)     w = 16;
  if(h > buflen) h = buflen;

  for(y=0;y<h;y++){
    d = 0;
    for(x=(w-1)/8; x>=0; x--){
      d <<= 8;
      d |= glyph->bitmap[y * bpl+x];
    }
    buf[y] = d;
  }
  return h;
}

void sjis2euc(int c1, int c2, int *pE1, int *pE2)
{
  if (0xa1 <= c1 && c1 <= 0xdf) {
    c2 = c1;
    c1 = 0x8e;
  } else if(0x9f <= c2) {
    c1 = c1 * 2 - (c1 >= 0xe0 ? 0xe0 : 0x60);
    c2 += 2;
  } else {
    c1 = c1 * 2 - (c1 >= 0xe0 ? 0xe1 : 0x61);
    c2 += 0x60 + (c2 < 0x7f);
  }
  *pE1 = c1;
  *pE2 = c2;
}

void dk_wait_scroll_end(dcont_t *dcont)
{
  sio_t *scont = &dcont->scont;
  char *r;
  int i,m;

  for(i=0;i<100;i++){
    r = sio_cmd(scont,"sc_mode");
    if(f_v > 1) fprintf(stderr,"sc_mode:%s",r);
    if(sscanf(r,"D %d",&m)>0 && (m == 1 || m == 0))
      break;
    usleep(100000);
  }
}
