#ifndef _sio_h
#define _sio_h

typedef struct _sio_t {
  char   *tty_name;
  int    tty_baud;
#ifdef __CYGWIN__
  HANDLE comHandle;
#else
  int    tty_h;
#endif
  int    f_v;
} sio_t;

void sio_init(sio_t *scont);
void sio_open(sio_t *hcont);
void sio_close(sio_t *hcont);
int  sio_getc(sio_t *hcont);
int  sio_getc0(sio_t *hcont,unsigned char *pC);
void sio_putc(sio_t *hcont, int c);
void sio_input_purge(sio_t *hcont);
void sio_rts_set(sio_t *hcont, int val);
void sio_dtr_set(sio_t *hcont, int val);
int  sio_write(sio_t *hcont,const char *buf, int len);
void sio_putc_e(sio_t *hcont,int c);
int sio_read(sio_t *hcont, char *buf, int len);
/* void sio_block_set(sio_t *hcont,int bOn); */
void sio_puts(sio_t *scont, const char *str);
char *sio_gets(sio_t *scont, char *buf, int buflen);
void sio_sync(sio_t *scont);
char *sio_cmd(sio_t *scont,const char *cmd_fmt, ...);

#endif /* _sio_h */
